(*Andrew Willouer
COMS 4115 Programming Languages and Translators
8/10/2009*)                    

(*Ast.mli
Consists of all the types for the AIC language*)

(*Binary Operators*)
type op = Add | Sub | Mult | Div | Equal | Neq | Less | Leq | Greater | Geq | And | Or

(*Scope Global or Local*)  
type scope = Global | Local

(*Types, int, string, bool implemented, the rest for future development*)
type types =
    Int
  | StringType
  | Bool 
  | Card
  | Hand
  | Deck
  | Player

    
type varexp = VarExp of string * scope
(*Expression Type*)  
and expr =
    Intliteral of int
  | Variable of varexp
  | Stringliteral of string
  | Id of string
  | Binop of expr * op * expr
  | Call of string * expr list
  | Cardliteral of string
  | Handliteral of string * int  (*Handliteral contains a cardliteral "2C" and the cards value*)
  | Boolliteral of bool
  | Assign of varexp * expr
  | Noexpr

(*Statements*)    
type stmt =
    Expr of expr
  | Return of expr
  | Print of expr
  | Read of varexp
  | If of expr * stmt list * stmt list
  | For of expr * expr * expr * stmt
  | While of expr * stmt list
  | Deal of varexp
  | Value of expr

(*function declaration *)
type func_decl = {
    fname : string;
    formals : string list;
    locals : string list;
    body : stmt list;
                 }

type program = string list * func_decl list
